NodeImpl (Xerces2 Implementation)
Date: 2016-02-03

org.apache.xerces.dom

## Class NodeImpl

- java.lang.Object
- - org.apache.xerces.dom.NodeImpl

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, org.w3c.dom.events.EventTarget, org.w3c.dom.Node, org.w3c.dom.NodeList
  Direct Known Subclasses:
    AttrImpl, ChildNode, NotationImpl

      public abstract class NodeImpl
      extends java.lang.Object
      implements org.w3c.dom.Node, org.w3c.dom.NodeList, org.w3c.dom.events.EventTarget, java.lang.Cloneable, java.io.Serializable

  NodeImpl provides the basic structure of a DOM tree. It is never used directly, but instead is subclassed to add type and data information, and additional methods, appropriate to each node of the tree. Only its subclasses should be instantiated -- and those, with the exception of Document itself, only through a specific Document's factory methods.

  The Node interface provides shared behaviors such as siblings and children, both for consistancy and so that the most common tree operations may be performed without constantly having to downcast to specific node types. When there is no obvious mapping for one of these queries, it will respond with null. Note that the default behavior is that children are forbidden. To permit them, the subclass ParentNode overrides several methods.

  NodeImpl also implements NodeList, so it can return itself in response to the getChildNodes() query. This eliminiates the need for a separate ChildNodeList object. Note that this is an IMPLEMENTATION DETAIL; applications should _never_ assume that this identity exists.

  All nodes in a single document must originate in that document. (Note that this is much tighter than "must be same implementation") Nodes are all aware of their ownerDocument, and attempts to mismatch will throw WRONG_DOCUMENT_ERR.

  However, to save memory not all nodes always have a direct reference to their ownerDocument. When a node is owned by another node it relies on its owner to store its ownerDocument. Parent nodes always store it though, so there is never more than one level of indirection. And when a node doesn't have an owner, ownerNode refers to its ownerDocument.

  This class doesn't directly support mutation events, however, it still implements the EventTarget interface and forward all related calls to the document so that the document class do so.

  Since:
    PR-DOM-Level-1-19980818.
  Version:
    $Id: NodeImpl.java 814769 2009-09-14 18:25:54Z mrglavas $
  Author:
    Arnaud Le Hors, IBM, Joe Kesselman, IBM
  See Also:
    Serialized Form

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `DOCUMENT_POSITION_CONTAINS`
    `static short` | `DOCUMENT_POSITION_DISCONNECTED`
    `static short` | `DOCUMENT_POSITION_FOLLOWING`
    `static short` | `DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC`
    `static short` | `DOCUMENT_POSITION_IS_CONTAINED`
    `static short` | `DOCUMENT_POSITION_PRECEDING`
    `static short` | `ELEMENT_DEFINITION_NODE` Element definition node type.
    `protected static short` | `FIRSTCHILD`
    `protected short` | `flags`
    `protected static short` | `HASSTRING`
    `protected static short` | `ID`
    `protected static short` | `IGNORABLEWS`
    `protected static short` | `NORMALIZED`
    `protected static short` | `OWNED`
    `protected NodeImpl` | `ownerNode`
    `protected static short` | `READONLY`
    `protected static short` | `SPECIFIED`
    `protected static short` | `SYNCCHILDREN`
    `protected static short` | `SYNCDATA`
    `static short` | `TREE_POSITION_ANCESTOR` The node is an ancestor of the reference node.
    `static short` | `TREE_POSITION_DESCENDANT` The node is a descendant of the reference node.
    `static short` | `TREE_POSITION_DISCONNECTED` The two nodes are disconnected, they do not have any common ancestor.
    `static short` | `TREE_POSITION_EQUIVALENT` The two nodes have an equivalent position.
    `static short` | `TREE_POSITION_FOLLOWING` The node follows the reference node.
    `static short` | `TREE_POSITION_PRECEDING` The node precedes the reference node.
    `static short` | `TREE_POSITION_SAME_NODE` The two nodes are the same.

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `NodeImpl()` Constructor for serialization.
    `protected` | `NodeImpl(CoreDocumentImpl ownerDocument)` No public constructor; only subclasses of Node should be instantiated, and those normally via a Document's factory methods

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addEventListener(java.lang.String type, org.w3c.dom.events.EventListener listener, boolean useCapture)` This method allows the registration of event listeners on the event target.
    `org.w3c.dom.Node` | `appendChild(org.w3c.dom.Node newChild)` Adds a child node to the end of the list of children for this node.
    `protected void` | `changed()` Denotes that this node has changed.
    `protected int` | `changes()` Returns the number of changes to this node.
    `org.w3c.dom.Node` | `cloneNode(boolean deep)` Returns a duplicate of a given node.
    `short` | `compareDocumentPosition(org.w3c.dom.Node other)` Compares a node with this node with regard to their position in the document.
    `short` | `compareTreePosition(org.w3c.dom.Node other)` Deprecated.
    `boolean` | `dispatchEvent(org.w3c.dom.events.Event event)` This method allows the dispatch of events into the implementations event model.
    `org.w3c.dom.NamedNodeMap` | `getAttributes()` Return the collection of attributes associated with this node, or null if none.
    `java.lang.String` | `getBaseURI()` The absolute base URI of this node or `null` if undefined.
    `org.w3c.dom.NodeList` | `getChildNodes()` Obtain a NodeList enumerating all children of this node.
    `protected org.w3c.dom.Node` | `getContainer()` For non-child nodes, the node which "points" to this node.
    `java.lang.Object` | `getFeature(java.lang.String feature, java.lang.String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
    `org.w3c.dom.Node` | `getFirstChild()` The first child of this Node, or null if none.
    `org.w3c.dom.Node` | `getLastChild()` The first child of this Node, or null if none.
    `int` | `getLength()` NodeList method: Count the immediate children of this node
    `java.lang.String` | `getLocalName()` Introduced in DOM Level 2.
    `java.lang.String` | `getNamespaceURI()` Introduced in DOM Level 2.
    `org.w3c.dom.Node` | `getNextSibling()` The next child of this node's parent, or null if none
    `abstract java.lang.String` | `getNodeName()` the name of this node.
    `protected int` | `getNodeNumber()` Returns the node number
    `abstract short` | `getNodeType()` A short integer indicating what type of node this is.
    `java.lang.String` | `getNodeValue()` Returns the node value.
    `org.w3c.dom.Document` | `getOwnerDocument()` Find the Document that this Node belongs to (the document in whose context the Node was created).
    `org.w3c.dom.Node` | `getParentNode()` Obtain the DOM-tree parent of this node, or null if it is not currently active in the DOM tree (perhaps because it has just been created or removed).
    `java.lang.String` | `getPrefix()` Introduced in DOM Level 2.
    `org.w3c.dom.Node` | `getPreviousSibling()` The previous child of this node's parent, or null if none
    `boolean` | `getReadOnly()` NON-DOM: Returns true if this node is read-only.
    `java.lang.String` | `getTextContent()` This attribute returns the text content of this node and its descendants.
    `java.lang.Object` | `getUserData()` NON-DOM: Returns the user data associated to this node.
    `java.lang.Object` | `getUserData(java.lang.String key)` Retrieves the object associated to a key on a this node.
    `protected java.util.Hashtable` | `getUserDataRecord()`
    `boolean` | `hasAttributes()` Returns whether this node (if it is an element) has any attributes.
    `boolean` | `hasChildNodes()` Test whether this node has any children.
    `org.w3c.dom.Node` | `insertBefore(org.w3c.dom.Node newChild, org.w3c.dom.Node refChild)` Move one or more node(s) to our list of children.
    `boolean` | `isDefaultNamespace(java.lang.String namespaceURI)` DOM Level 3: Experimental This method checks if the specified `namespaceURI` is the default namespace or not.
    `boolean` | `isEqualNode(org.w3c.dom.Node arg)` Tests whether two nodes are equal.
    `boolean` | `isSameNode(org.w3c.dom.Node other)` Returns whether this node is the same node as the given one.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Introduced in DOM Level 2.
    `org.w3c.dom.Node` | `item(int index)` NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.
    `java.lang.String` | `lookupNamespaceURI(java.lang.String specifiedPrefix)` DOM Level 3 - Experimental: Look up the namespace URI associated to the given prefix, starting from this node.
    `java.lang.String` | `lookupPrefix(java.lang.String namespaceURI)` DOM Level 3 - Experimental: Look up the prefix associated to the given namespace URI, starting from this node.
    `void` | `needsSyncChildren(boolean value)`
    `void` | `normalize()` Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes.
    `org.w3c.dom.Node` | `removeChild(org.w3c.dom.Node oldChild)` Remove a child from this Node.
    `void` | `removeEventListener(java.lang.String type, org.w3c.dom.events.EventListener listener, boolean useCapture)` This method allows the removal of event listeners from the event target.
    `org.w3c.dom.Node` | `replaceChild(org.w3c.dom.Node newChild, org.w3c.dom.Node oldChild)` Make newChild occupy the location that oldChild used to have.
    `void` | `setNodeValue(java.lang.String x)` Sets the node value.
    `protected void` | `setOwnerDocument(CoreDocumentImpl doc)` NON-DOM set the ownerDocument of this node
    `void` | `setPrefix(java.lang.String prefix)` Introduced in DOM Level 2.
    `void` | `setReadOnly(boolean readOnly, boolean deep)` NON-DOM: PR-DOM-Level-1-19980818 mentions readonly nodes in conjunction with Entities, but provides no API to support this.
    `void` | `setTextContent(java.lang.String textContent)` This attribute returns the text content of this node and its descendants.
    `void` | `setUserData(java.lang.Object data)` NON-DOM: As an alternative to subclassing the DOM, this implementation has been extended with the ability to attach an object to each node.
    `java.lang.Object` | `setUserData(java.lang.String key, java.lang.Object data, org.w3c.dom.UserDataHandler handler)` Associate an object to a key on this node.
    `protected void` | `synchronizeData()` Override this method in subclass to hook in efficient internal data structure.
    `java.lang.String` | `toString()` NON-DOM method for debugging convenience.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### TREE_POSITION_PRECEDING

          public static final short TREE_POSITION_PRECEDING

      The node precedes the reference node.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_FOLLOWING

          public static final short TREE_POSITION_FOLLOWING

      The node follows the reference node.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_ANCESTOR

          public static final short TREE_POSITION_ANCESTOR

      The node is an ancestor of the reference node.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_DESCENDANT

          public static final short TREE_POSITION_DESCENDANT

      The node is a descendant of the reference node.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_EQUIVALENT

          public static final short TREE_POSITION_EQUIVALENT

      The two nodes have an equivalent position. This is the case of two attributes that have the same `ownerElement`, and two nodes that are the same.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_SAME_NODE

          public static final short TREE_POSITION_SAME_NODE

      The two nodes are the same. Two nodes that are the same have an equivalent position, though the reverse may not be true.
      See Also:
        Constant Field Values

    - #### TREE_POSITION_DISCONNECTED

          public static final short TREE_POSITION_DISCONNECTED

      The two nodes are disconnected, they do not have any common ancestor. This is the case of two nodes that are not in the same document.
      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_DISCONNECTED

          public static final short DOCUMENT_POSITION_DISCONNECTED

      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_PRECEDING

          public static final short DOCUMENT_POSITION_PRECEDING

      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_FOLLOWING

          public static final short DOCUMENT_POSITION_FOLLOWING

      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_CONTAINS

          public static final short DOCUMENT_POSITION_CONTAINS

      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_IS_CONTAINED

          public static final short DOCUMENT_POSITION_IS_CONTAINED

      See Also:
        Constant Field Values

    - #### DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC

          public static final short DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC

      See Also:
        Constant Field Values

    - #### ELEMENT_DEFINITION_NODE

          public static final short ELEMENT_DEFINITION_NODE

      Element definition node type.
      See Also:
        Constant Field Values

    - #### ownerNode

          protected NodeImpl ownerNode

    - #### flags

          protected short flags

    - #### READONLY

          protected static final short READONLY

      See Also:
        Constant Field Values

    - #### SYNCDATA

          protected static final short SYNCDATA

      See Also:
        Constant Field Values

    - #### SYNCCHILDREN

          protected static final short SYNCCHILDREN

      See Also:
        Constant Field Values

    - #### OWNED

          protected static final short OWNED

      See Also:
        Constant Field Values

    - #### FIRSTCHILD

          protected static final short FIRSTCHILD

      See Also:
        Constant Field Values

    - #### SPECIFIED

          protected static final short SPECIFIED

      See Also:
        Constant Field Values

    - #### IGNORABLEWS

          protected static final short IGNORABLEWS

      See Also:
        Constant Field Values

    - #### HASSTRING

          protected static final short HASSTRING

      See Also:
        Constant Field Values

    - #### NORMALIZED

          protected static final short NORMALIZED

      See Also:
        Constant Field Values

    - #### ID

          protected static final short ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### NodeImpl

          protected NodeImpl(CoreDocumentImpl ownerDocument)

      No public constructor; only subclasses of Node should be instantiated, and those normally via a Document's factory methods

      Every Node knows what Document it belongs to.

    - #### NodeImpl

          public NodeImpl()

      Constructor for serialization.

  - ### Method Detail

    - #### getNodeType

          public abstract short getNodeType()

      A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.
      Specified by:
        `getNodeType` in interface `org.w3c.dom.Node`

    - #### getNodeName

          public abstract java.lang.String getNodeName()

      the name of this node.
      Specified by:
        `getNodeName` in interface `org.w3c.dom.Node`

    - #### getNodeValue

          public java.lang.String getNodeValue()
                                        throws org.w3c.dom.DOMException

      Returns the node value.
      Specified by:
        `getNodeValue` in interface `org.w3c.dom.Node`
      Throws:
        `DOMException(DOMSTRING_SIZE_ERR)`
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

    - #### setNodeValue

          public void setNodeValue(java.lang.String x)
                            throws org.w3c.dom.DOMException

      Sets the node value.
      Specified by:
        `setNodeValue` in interface `org.w3c.dom.Node`
      Throws:
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)`
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly and if it is not defined to be `null`.

    - #### appendChild

          public org.w3c.dom.Node appendChild(org.w3c.dom.Node newChild)
                                       throws org.w3c.dom.DOMException

      Adds a child node to the end of the list of children for this node. Convenience shorthand for insertBefore(newChild,null).
      Specified by:
        `appendChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
      Returns:
        newChild, in its new state (relocated, or emptied in the case of DocumentNode.)
      Throws:
        `DOMException(HIERARCHY_REQUEST_ERR)` - if newChild is of a type that shouldn't be a child of this node.
        `DOMException(WRONG_DOCUMENT_ERR)` - if newChild has a different owner document than we do.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if this node is read-only.
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors or this node itself, or if this node is of type `Document` and the DOM application attempts to append a second `DocumentType` or `Element` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the previous parent of the node being inserted is readonly.
        NOT_SUPPORTED_ERR: if the `newChild` node is a child of the `Document` node, this exception might be raised if the DOM implementation doesn't support the removal of the `DocumentType` child or `Element` child.
      See Also:
        `

        By default we do not accept any children, ParentNode overrides this.

        `, `ParentNode`

    - #### cloneNode

          public org.w3c.dom.Node cloneNode(boolean deep)

      Returns a duplicate of a given node. You can consider this a generic "copy constructor" for nodes. The newly returned object should be completely independent of the source object's subtree, so changes in one after the clone has been made will not affect the other.

      Note: since we never have any children deep is meaningless here, ParentNode overrides this behavior.

      Specified by:
        `cloneNode` in interface `org.w3c.dom.Node`
      Parameters:
        `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
      Returns:
        The duplicate node.
      See Also:
        `

        Example: Cloning a Text node will copy both the node and the text it contains.

        Example: Cloning something that has children -- Element or Attr, for example -- will _not_ clone those children unless a "deep clone" has been requested. A shallow clone of an Attr node will yield an empty Attr of the same name.

        NOTE: Clones will always be read/write, even if the node being cloned is read-only, to permit applications using only the DOM API to obtain editable copies of locked portions of the tree.

        `

    - #### getOwnerDocument

          public org.w3c.dom.Document getOwnerDocument()

      Find the Document that this Node belongs to (the document in whose context the Node was created). The Node may or may not currently be part of that Document's actual contents.
      Specified by:
        `getOwnerDocument` in interface `org.w3c.dom.Node`

    - #### setOwnerDocument

          protected void setOwnerDocument(CoreDocumentImpl doc)

      NON-DOM set the ownerDocument of this node

    - #### getNodeNumber

          protected int getNodeNumber()

      Returns the node number

    - #### getParentNode

          public org.w3c.dom.Node getParentNode()

      Obtain the DOM-tree parent of this node, or null if it is not currently active in the DOM tree (perhaps because it has just been created or removed). Note that Document, DocumentFragment, and Attribute will never have parents.
      Specified by:
        `getParentNode` in interface `org.w3c.dom.Node`

    - #### getNextSibling

          public org.w3c.dom.Node getNextSibling()

      The next child of this node's parent, or null if none
      Specified by:
        `getNextSibling` in interface `org.w3c.dom.Node`

    - #### getPreviousSibling

          public org.w3c.dom.Node getPreviousSibling()

      The previous child of this node's parent, or null if none
      Specified by:
        `getPreviousSibling` in interface `org.w3c.dom.Node`

    - #### getAttributes

          public org.w3c.dom.NamedNodeMap getAttributes()

      Return the collection of attributes associated with this node, or null if none. At this writing, Element is the only type of node which will ever have attributes.
      Specified by:
        `getAttributes` in interface `org.w3c.dom.Node`
      See Also:
        `ElementImpl`

    - #### hasAttributes

          public boolean hasAttributes()

      Returns whether this node (if it is an element) has any attributes.
      Specified by:
        `hasAttributes` in interface `org.w3c.dom.Node`
      Returns:
        `true` if this node has any attributes, `false` otherwise.
      Since:
        DOM Level 2
      See Also:
        `ElementImpl`

    - #### hasChildNodes

          public boolean hasChildNodes()

      Test whether this node has any children. Convenience shorthand for (Node.getFirstChild()!=null)

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `hasChildNodes` in interface `org.w3c.dom.Node`
      Returns:
        Returns `true` if this node has any children, `false` otherwise.
      See Also:
        `ParentNode`

    - #### getChildNodes

          public org.w3c.dom.NodeList getChildNodes()

      Obtain a NodeList enumerating all children of this node. If there are none, an (initially) empty NodeList is returned.

      NodeLists are "live"; as children are added/removed the NodeList will immediately reflect those changes. Also, the NodeList refers to the actual nodes, so changes to those nodes made via the DOM tree will be reflected in the NodeList and vice versa.

      In this implementation, Nodes implement the NodeList interface and provide their own getChildNodes() support. Other DOMs may solve this differently.

      Specified by:
        `getChildNodes` in interface `org.w3c.dom.Node`

    - #### getFirstChild

          public org.w3c.dom.Node getFirstChild()

      The first child of this Node, or null if none.

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `getFirstChild` in interface `org.w3c.dom.Node`
      See Also:
        `ParentNode`

    - #### getLastChild

          public org.w3c.dom.Node getLastChild()

      The first child of this Node, or null if none.

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `getLastChild` in interface `org.w3c.dom.Node`
      See Also:
        `ParentNode`

    - #### insertBefore

          public org.w3c.dom.Node insertBefore(org.w3c.dom.Node newChild,
                                      org.w3c.dom.Node refChild)
                                        throws org.w3c.dom.DOMException

      Move one or more node(s) to our list of children. Note that this implicitly removes them from their previous parent.

      By default we do not accept any children, ParentNode overrides this.

      Specified by:
        `insertBefore` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The Node to be moved to our subtree. As a convenience feature, inserting a DocumentNode will instead insert all its children.
        `refChild` - Current child which newChild should be placed immediately before. If refChild is null, the insertion occurs after all existing Nodes, like appendChild().
      Returns:
        newChild, in its new state (relocated, or emptied in the case of DocumentNode.)
      Throws:
        `DOMException(HIERARCHY_REQUEST_ERR)` - if newChild is of a type that shouldn't be a child of this node, or if newChild is an ancestor of this node.
        `DOMException(WRONG_DOCUMENT_ERR)` - if newChild has a different owner document than we do.
        `DOMException(NOT_FOUND_ERR)` - if refChild is not a child of this node.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if this node is read-only.
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors or this node itself, or if this node is of type `Document` and the DOM application attempts to insert a second `DocumentType` or `Element` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the parent of the node being inserted is readonly.
        NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the insertion of a `DocumentType` or `Element` node.
      See Also:
        `ParentNode`

    - #### removeChild

          public org.w3c.dom.Node removeChild(org.w3c.dom.Node oldChild)
                                       throws org.w3c.dom.DOMException

      Remove a child from this Node. The removed child's subtree remains intact so it may be re-inserted elsewhere.

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `removeChild` in interface `org.w3c.dom.Node`
      Parameters:
        `oldChild` - The node being removed.
      Returns:
        oldChild, in its new state (removed).
      Throws:
        `DOMException(NOT_FOUND_ERR)` - if oldChild is not a child of this node.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if this node is read-only.
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the removal of the `DocumentType` child or the `Element` child.
      See Also:
        `ParentNode`

    - #### replaceChild

          public org.w3c.dom.Node replaceChild(org.w3c.dom.Node newChild,
                                      org.w3c.dom.Node oldChild)
                                        throws org.w3c.dom.DOMException

      Make newChild occupy the location that oldChild used to have. Note that newChild will first be removed from its previous parent, if any. Equivalent to inserting newChild before oldChild, then removing oldChild.

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `replaceChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The new node to put in the child list.
        `oldChild` - The node being replaced in the list.
      Returns:
        oldChild, in its new state (removed).
      Throws:
        `DOMException(HIERARCHY_REQUEST_ERR)` - if newChild is of a type that shouldn't be a child of this node, or if newChild is one of our ancestors.
        `DOMException(WRONG_DOCUMENT_ERR)` - if newChild has a different owner document than we do.
        `DOMException(NOT_FOUND_ERR)` - if oldChild is not a child of this node.
        `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if this node is read-only.
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to put in is one of this node's ancestors or this node itself, or if this node is of type `Document` and the result of the replacement operation would add a second `DocumentType` or `Element` on the `Document` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the parent of the new node is readonly.
        NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the replacement of the `DocumentType` child or `Element` child.
      See Also:
        `ParentNode`

    - #### getLength

          public int getLength()

      NodeList method: Count the immediate children of this node

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `getLength` in interface `org.w3c.dom.NodeList`
      Returns:
        int
      See Also:
        `ParentNode`

    - #### item

          public org.w3c.dom.Node item(int index)

      NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.

      By default we do not have any children, ParentNode overrides this.

      Specified by:
        `item` in interface `org.w3c.dom.NodeList`
      Parameters:
        `index` - int
      Returns:
        org.w3c.dom.Node
      See Also:
        `ParentNode`

    - #### normalize

          public void normalize()

      Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.

      Note that this implementation simply calls normalize() on this Node's children. It is up to implementors or Node to override normalize() to take action.

      Specified by:
        `normalize` in interface `org.w3c.dom.Node`

    - #### isSupported

          public boolean isSupported(java.lang.String feature,
                            java.lang.String version)

      Introduced in DOM Level 2.

      Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

      Specified by:
        `isSupported` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` - The package name of the feature to test. This is the same name as what can be passed to the method hasFeature on DOMImplementation.
        `version` - This is the version number of the package name to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return true.
      Returns:
        boolean Returns true if this node defines a subtree within which the specified feature is supported, false otherwise.
      Since:
        WD-DOM-Level-2-19990923

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI()

      Introduced in DOM Level 2.

      The namespace URI of this node, or null if it is unspecified. When this node is of any type other than ELEMENT_NODE and ATTRIBUTE_NODE, this is always null and setting it has no effect.

      This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.

      For nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is null.

      Specified by:
        `getNamespaceURI` in interface `org.w3c.dom.Node`
      Since:
        WD-DOM-Level-2-19990923
      See Also:
        `AttrNSImpl`, `ElementNSImpl`

    - #### getPrefix

          public java.lang.String getPrefix()

      Introduced in DOM Level 2.

      The namespace prefix of this node, or null if it is unspecified. When this node is of any type other than ELEMENT_NODE and ATTRIBUTE_NODE this is always null and setting it has no effect.

      For nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is null.

      Specified by:
        `getPrefix` in interface `org.w3c.dom.Node`
      Since:
        WD-DOM-Level-2-19990923
      See Also:
        `AttrNSImpl`, `ElementNSImpl`

    - #### setPrefix

          public void setPrefix(java.lang.String prefix)
                         throws org.w3c.dom.DOMException

      Introduced in DOM Level 2.

      The namespace prefix of this node, or null if it is unspecified. When this node is of any type other than ELEMENT_NODE and ATTRIBUTE_NODE this is always null and setting it has no effect.

      For nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is null.

      Note that setting this attribute changes the nodeName attribute, which holds the qualified name, as well as the tagName and name attributes of the Element and Attr interfaces, when applicable.

      Specified by:
        `setPrefix` in interface `org.w3c.dom.Node`
      Throws:
        `INVALID_CHARACTER_ERR` - Raised if the specified prefix contains an invalid character.
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NAMESPACE_ERR: Raised if the specified `prefix` is malformed per the Namespaces in XML specification, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from " http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from "http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns" [XML Namespaces] .
      Since:
        WD-DOM-Level-2-19990923
      See Also:
        `AttrNSImpl`, `ElementNSImpl`

    - #### getLocalName

          public java.lang.String getLocalName()

      Introduced in DOM Level 2.

      Returns the local part of the qualified name of this node. For nodes created with a DOM Level 1 method, such as createElement from the Document interface, and for nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE this is the same as the nodeName attribute.

      Specified by:
        `getLocalName` in interface `org.w3c.dom.Node`
      Since:
        WD-DOM-Level-2-19990923
      See Also:
        `AttrNSImpl`, `ElementNSImpl`

    - #### addEventListener

          public void addEventListener(java.lang.String type,
                              org.w3c.dom.events.EventListener listener,
                              boolean useCapture)

      Description copied from interface: `org.w3c.dom.events.EventTarget`
      This method allows the registration of event listeners on the event target. If an `EventListener` is added to an `EventTarget` while it is processing an event, it will not be triggered by the current actions but may be triggered during a later stage of event flow, such as the bubbling phase.
      If multiple identical `EventListener`s are registered on the same `EventTarget` with the same parameters the duplicate instances are discarded. They do not cause the `EventListener` to be called twice and since they are discarded they do not need to be removed with the `removeEventListener` method.
      Specified by:
        `addEventListener` in interface `org.w3c.dom.events.EventTarget`
      Parameters:
        `type` - The event type for which the user is registering
        `listener` - The `listener` parameter takes an interface implemented by the user which contains the methods to be called when the event occurs.
        `useCapture` - If true, `useCapture` indicates that the user wishes to initiate capture. After initiating capture, all events of the specified type will be dispatched to the registered `EventListener` before being dispatched to any `EventTargets` beneath them in the tree. Events which are bubbling upward through the tree will not trigger an `EventListener` designated to use capture.

    - #### removeEventListener

          public void removeEventListener(java.lang.String type,
                                 org.w3c.dom.events.EventListener listener,
                                 boolean useCapture)

      Description copied from interface: `org.w3c.dom.events.EventTarget`
      This method allows the removal of event listeners from the event target. If an `EventListener` is removed from an `EventTarget` while it is processing an event, it will not be triggered by the current actions. `EventListener`s can never be invoked after being removed.
      Calling `removeEventListener` with arguments which do not identify any currently registered `EventListener` on the `EventTarget` has no effect.
      Specified by:
        `removeEventListener` in interface `org.w3c.dom.events.EventTarget`
      Parameters:
        `type` - Specifies the event type of the `EventListener` being removed.
        `listener` - The `EventListener` parameter indicates the `EventListener` to be removed.
        `useCapture` - Specifies whether the `EventListener` being removed was registered as a capturing listener or not. If a listener was registered twice, one with capture and one without, each must be removed separately. Removal of a capturing listener does not affect a non-capturing version of the same listener, and vice versa.

    - #### dispatchEvent

          public boolean dispatchEvent(org.w3c.dom.events.Event event)

      Description copied from interface: `org.w3c.dom.events.EventTarget`
      This method allows the dispatch of events into the implementations event model. Events dispatched in this manner will have the same capturing and bubbling behavior as events dispatched directly by the implementation. The target of the event is the `EventTarget` on which `dispatchEvent` is called.
      Specified by:
        `dispatchEvent` in interface `org.w3c.dom.events.EventTarget`
      Parameters:
        `event` - Specifies the event type, behavior, and contextual information to be used in processing the event.
      Returns:
        The return value of `dispatchEvent` indicates whether any of the listeners which handled the event called `preventDefault`. If `preventDefault` was called the value is false, else the value is true.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      The absolute base URI of this node or `null` if undefined. This value is computed according to . However, when the `Document` supports the feature "HTML" , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `Document` interface otherwise.
      When the node is an `Element`, a `Document` or a a `ProcessingInstruction`, this attribute represents the properties [base URI] defined in . When the node is a `Notation`, an `Entity`, or an `EntityReference`, this attribute represents the properties [declaration base URI] in the . How will this be affected by resolution of relative namespace URIs issue?It's not.Should this only be on Document, Element, ProcessingInstruction, Entity, and Notation nodes, according to the infoset? If not, what is it equal to on other nodes? Null? An empty string? I think it should be the parent's.No.Should this be read-only and computed or and actual read-write attribute?Read-only and computed (F2F 19 Jun 2000 and teleconference 30 May 2001).If the base HTML element is not yet attached to a document, does the insert change the Document.baseURI? Yes. (F2F 26 Sep 2001)
      Specified by:
        `getBaseURI` in interface `org.w3c.dom.Node`
      Since:
        DOM Level 3

    - #### compareTreePosition

          public short compareTreePosition(org.w3c.dom.Node other)

      Deprecated.
      Compares a node with this node with regard to their position in the tree and according to the document order. This order can be extended by module that define additional types of nodes.
      Parameters:
        `other` - The node to compare against this node.
      Returns:
        Returns how the given node is positioned relatively to this node.
      Since:
        DOM Level 3

    - #### compareDocumentPosition

          public short compareDocumentPosition(org.w3c.dom.Node other)
                                        throws org.w3c.dom.DOMException

      Compares a node with this node with regard to their position in the document.
      Specified by:
        `compareDocumentPosition` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to compare against this node.
      Returns:
        Returns how the given node is positioned relatively to this node.
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: when the compared nodes are from different DOM implementations that do not coordinate to return consistent implementation-specific results.
      Since:
        DOM Level 3

    - #### getTextContent

          public java.lang.String getTextContent()
                                          throws org.w3c.dom.DOMException

      This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      /** This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
      ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `getTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
      Since:
        DOM Level 3

    - #### setTextContent

          public void setTextContent(java.lang.String textContent)
                              throws org.w3c.dom.DOMException

      This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
      ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `setTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
      Since:
        DOM Level 3

    - #### isSameNode

          public boolean isSameNode(org.w3c.dom.Node other)

      Returns whether this node is the same node as the given one.
      This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.
      Specified by:
        `isSameNode` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to test against.
      Returns:
        Returns `true` if the nodes are the same, `false` otherwise.
      Since:
        DOM Level 3

    - #### isDefaultNamespace

          public boolean isDefaultNamespace(java.lang.String namespaceURI)

      DOM Level 3: Experimental This method checks if the specified `namespaceURI` is the default namespace or not.
      Specified by:
        `isDefaultNamespace` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` - The namespace URI to look for.
      Returns:
        `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.
      Since:
        DOM Level 3

    - #### lookupPrefix

          public java.lang.String lookupPrefix(java.lang.String namespaceURI)

      DOM Level 3 - Experimental: Look up the prefix associated to the given namespace URI, starting from this node.
      Specified by:
        `lookupPrefix` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` -
      Returns:
        the prefix for the namespace

    - #### lookupNamespaceURI

          public java.lang.String lookupNamespaceURI(java.lang.String specifiedPrefix)

      DOM Level 3 - Experimental: Look up the namespace URI associated to the given prefix, starting from this node. Use lookupNamespaceURI(null) to lookup the default namespace
      Specified by:
        `lookupNamespaceURI` in interface `org.w3c.dom.Node`
      Parameters:
        `specifiedPrefix` -
      Returns:
        the URI for the namespace
      Since:
        DOM Level 3

    - #### isEqualNode

          public boolean isEqualNode(org.w3c.dom.Node arg)

      Tests whether two nodes are equal.
      This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode`. All nodes that are the same will also be equal, though the reverse may not be true.
      Two nodes are equal if and only if the following conditions are satisfied: The two nodes are of the same type.The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` , `baseURI`. This is: they are both `null`, or they have the same length and are character for character identical. The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. This is true for `Attr` nodes as for any other type of node. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
      For two `DocumentType` nodes to be equal, the following conditions must also be satisfied: The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.The `entities` `NamedNodeMaps` are equal.The `notations` `NamedNodeMaps` are equal.
      On the other hand, the following do not affect equality: the `ownerDocument` attribute, the `specified` attribute for `Attr` nodes, the `isWhitespaceInElementContent` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.
      Specified by:
        `isEqualNode` in interface `org.w3c.dom.Node`
      Parameters:
        `arg` - The node to compare equality with.
      Returns:
        If the nodes, and possibly subtrees are equal, `true` otherwise `false`.
      Since:
        DOM Level 3

    - #### getFeature

          public java.lang.Object getFeature(java.lang.String feature,
                                    java.lang.String version)

      Description copied from interface: `org.w3c.dom.Node`
      This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in . The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in . This method also allow the implementation to provide specialized objects which do not support the `Node` interface.
      Specified by:
        `getFeature` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` - The name of the feature requested. Note that any plus sign "+" prepended to the name of the feature will be ignored since it is not significant in the context of this method.
        `version` - This is the version number of the feature to test.
      Returns:
        Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.
      Since:
        DOM Level 3

    - #### setUserData

          public java.lang.Object setUserData(java.lang.String key,
                                     java.lang.Object data,
                                     org.w3c.dom.UserDataHandler handler)

      Associate an object to a key on this node. The object can later be retrieved from this node by calling `getUserData` with the same key.
      Specified by:
        `setUserData` in interface `org.w3c.dom.Node`
      Parameters:
        `key` - The key to associate the object to.
        `data` - The object to associate to the given key, or `null` to remove any existing association to that key.
        `handler` - The handler to associate to that key, or `null`.
      Returns:
        Returns the `DOMObject` previously associated to the given key on this node, or `null` if there was none.
      Since:
        DOM Level 3

    - #### getUserData

          public java.lang.Object getUserData(java.lang.String key)

      Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.
      Specified by:
        `getUserData` in interface `org.w3c.dom.Node`
      Parameters:
        `key` - The key the object is associated to.
      Returns:
        Returns the `DOMObject` associated to the given key on this node, or `null` if there was none.
      Since:
        DOM Level 3

    - #### getUserDataRecord

          protected java.util.Hashtable getUserDataRecord()

    - #### setReadOnly

          public void setReadOnly(boolean readOnly,
                         boolean deep)

      NON-DOM: PR-DOM-Level-1-19980818 mentions readonly nodes in conjunction with Entities, but provides no API to support this.

      Most DOM users should not touch this method. Its anticpated use is during construction of EntityRefernces, where it will be used to lock the contents replicated from Entity so they can't be casually altered. It _could_ be published as a DOM extension, if desired.

      Note: since we never have any children deep is meaningless here, ParentNode overrides this behavior.

      Parameters:
        `readOnly` - True or false as desired.
        `deep` - If true, children are also toggled. Note that this will not change the state of an EntityReference or its children, which are always read-only.
      See Also:
        `ParentNode`

    - #### getReadOnly

          public boolean getReadOnly()

      NON-DOM: Returns true if this node is read-only. This is a shallow check.

    - #### setUserData

          public void setUserData(java.lang.Object data)

      NON-DOM: As an alternative to subclassing the DOM, this implementation has been extended with the ability to attach an object to each node. (If you need multiple objects, you can attach a collection such as a vector or hashtable, then attach your application information to that.)

      Important Note: You are responsible for removing references to your data on nodes that are no longer used. Failure to do so will prevent the nodes, your data is attached to, to be garbage collected until the whole document is.

      Parameters:
        `data` - the object to store or null to remove any existing reference

    - #### getUserData

          public java.lang.Object getUserData()

      NON-DOM: Returns the user data associated to this node.

    - #### changed

          protected void changed()

      Denotes that this node has changed.

    - #### changes

          protected int changes()

      Returns the number of changes to this node.

    - #### synchronizeData

          protected void synchronizeData()

      Override this method in subclass to hook in efficient internal data structure.

    - #### getContainer

          protected org.w3c.dom.Node getContainer()

      For non-child nodes, the node which "points" to this node. For example, the owning element for an attribute

    - #### needsSyncChildren

          public final void needsSyncChildren(boolean value)

    - #### toString

          public java.lang.String toString()

      NON-DOM method for debugging convenience.
      Overrides:
        `toString` in class `java.lang.Object`

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.